unit RInput;

interface

uses Windows;

const USER32                      = 'User32.DLL';
      RIM_INPUT                   = 0;
      RIM_INPUTSINK               = 1;
      RIM_TYPEHID                 = 2;
      RIM_TYPEKEYBOARD            = 1;
      RIM_TYPEMOUSE               = 0;
      RIDI_DEVICENAME             = $20000007;
      RIDI_DEVICEINFO             = $2000000b;
      RIDI_PREPARSEDDATA          = $20000005;
      RIDEV_REMOVE                = $00000001;
      RIDEV_EXCLUDE               = $00000010;
      RIDEV_PAGEONLY              = $00000020;
      RIDEV_NOLEGACY              = $00000030;
      RIDEV_INPUTSINK             = $00000100;
      RIDEV_CAPTUREMOUSE          = $00000200;
      RIDEV_NOHOTKEYS             = $00000200;
      RIDEV_APPKEYS               = $00000400;
      RIDEV_EXMODEMASK            = $000000F0;
      RI_MOUSE_LEFT_BUTTON_DOWN   = $0001;
      RI_MOUSE_LEFT_BUTTON_UP     = $0002;
      RI_MOUSE_RIGHT_BUTTON_DOWN  = $0004;
      RI_MOUSE_RIGHT_BUTTON_UP    = $0008;
      RI_MOUSE_MIDDLE_BUTTON_DOWN = $0010;
      RI_MOUSE_MIDDLE_BUTTON_UP   = $0020;
      RI_MOUSE_BUTTON_1_DOWN      = RI_MOUSE_LEFT_BUTTON_DOWN;
      RI_MOUSE_BUTTON_1_UP        = RI_MOUSE_LEFT_BUTTON_UP;
      RI_MOUSE_BUTTON_2_DOWN      = RI_MOUSE_RIGHT_BUTTON_DOWN;
      RI_MOUSE_BUTTON_2_UP        = RI_MOUSE_RIGHT_BUTTON_UP;
      RI_MOUSE_BUTTON_3_DOWN      = RI_MOUSE_MIDDLE_BUTTON_DOWN;
      RI_MOUSE_BUTTON_3_UP        = RI_MOUSE_MIDDLE_BUTTON_UP;
      RI_MOUSE_BUTTON_4_DOWN      = $0040;
      RI_MOUSE_BUTTON_4_UP        = $0080;
      RI_MOUSE_BUTTON_5_DOWN      = $0100;
      RI_MOUSE_BUTTON_5_UP        = $0200;
      RI_MOUSE_WHEEL              = $0400;
      MOUSE_MOVE_RELATIVE         = 0;
      MOUSE_MOVE_ABSOLUTE         = 1;
      MOUSE_VIRTUAL_DESKTOP       = $02;
      MOUSE_ATTRIBUTES_CHANGED    = $04;
      RID_HEADER                  = $10000005;
      RID_INPUT                   = $10000003;

type
 HRAWINPUT = THANDLE;

 tagRAWINPUTDEVICELIST = record
  hDevice:THandle;
  dwType:DWORD;
 end;

 tagRID_DEVICE_INFO_HID = record
    dwVendorId: DWORD;
    dwProductId: DWORD;
    dwVersionNumber: DWORD;
    usUsagePage: WORD;
    usUsage: WORD;
  end;

 tagRID_DEVICE_INFO_KEYBOARD = record
    dwType: DWORD;
    dwSubType: DWORD;
    dwKeyboardMode: DWORD;
    dwNumberOfFunctionKeys: DWORD;
    dwNumberOfIndicators: DWORD;
    dwNumberOfKeysTotal: DWORD;
  end; 

 tagRID_DEVICE_INFO_MOUSE = record
    dwId: DWORD;
    dwNumberOfButtons: DWORD;
    dwSampleRate: DWORD;
  end;

 tagRAWINPUTHEADER = record
    dwType: DWORD;
    dwSize: DWORD;
    hDevice: THANDLE;
    wParam: WPARAM;
  end;

 RAWINPUTHEADER = tagRAWINPUTHEADER;

 tagRAWMOUSE = record
    usFlags: WORD;
    union: record
    case Integer of
      0: (
        ulButtons: ULONG);
      1: (
        usButtonFlags: WORD;
        usButtonData: WORD);
    end;
    ulRawButtons: ULONG;
    lLastX: LongInt;
    lLastY: LongInt;
    ulExtraInformation: ULONG;
  end;

 RAWMOUSE = tagRAWMOUSE;

 tagRAWKEYBOARD = record
    MakeCode: WORD;
    Flags: WORD;
    Reserved: WORD;
    VKey: WORD;
    Message: UINT;
    ExtraInformation: ULONG;
  end;

 RAWKEYBOARD = tagRAWKEYBOARD;

 tagRAWHID = record
    dwSizeHid: DWORD;
    dwCount: DWORD;
    bRawData: array [0..0] of BYTE;
  end;

 RAWHID = tagRAWHID;

 tagRAWINPUT = record
    header: RAWINPUTHEADER;
    case Integer of
      0: (mouse: RAWMOUSE);
      1: (keyboard: RAWKEYBOARD);
      2: (hid: RAWHID);
  end;

 RID_DEVICE_INFO_HID       = tagRID_DEVICE_INFO_HID;
 RID_DEVICE_INFO_KEYBOARD  = tagRID_DEVICE_INFO_KEYBOARD; 
 RID_DEVICE_INFO_MOUSE     = tagRID_DEVICE_INFO_MOUSE;
 PRAWINPUT                 = ^tagRAWINPUT;
 RAWINPUT                  = tagRAWINPUT;
 tagRAWINPUTDEVICE = record
    usUsagePage: WORD;
    usUsage: WORD;
    dwFlags: DWORD;
    hwndTarget: HWND;
  end;
 RAWINPUTDEVICE  = tagRAWINPUTDEVICE;
 PRAWINPUTDEVICE = ^RAWINPUTDEVICE;

 tagRID_DEVICE_INFO = record
    cbSize: DWORD;
    dwType: DWORD;
    case Integer of
    0: (mouse: RID_DEVICE_INFO_MOUSE);
    1: (keyboard: RID_DEVICE_INFO_KEYBOARD);
    2: (hid: RID_DEVICE_INFO_HID);
  end;

 RID_DEVICE_INFO = tagRID_DEVICE_INFO;
 
 TRAWINPUTDEVICELIST = tagRAWINPUTDEVICELIST;
 PRAWINPUTDEVICELIST = ^TRAWINPUTDEVICELIST;

  TGetRawInputDeviceList = function (pRawInputDeviceList: PRAWINPUTDEVICELIST;
    var puiNumDevices: UINT; cbSize: UINT): UINT; stdcall;
    
  TGetRawInputDeviceInfo = function (hDevice: THANDLE; uiCommand: UINT; pData: POINTER;
    var pcbSize: UINT): UINT; stdcall;

  TGetRawInputBuffer = function (pData: PRAWINPUT; var pcbSize: UINT;
    cbSizeHeader: UINT): UINT; stdcall;

  TGetRawInputData = function (hRawInput: HRAWINPUT; uiCommand: UINT; pData: POINTER;
    var pcbSize: UINT; cbSizeHeader: UINT): UINT; stdcall;

  TRegisterRawInputDevices = function (pRawInputDevices: PRAWINPUTDEVICE;
    uiNumDevices: UINT; cbSize: UINT): BOOL; stdcall;

  TGetRegisteredRawInputDevices = function (pRawInputDevices: PRAWINPUTDEVICE;
    var puiNumDevices: UINT; cbSize: UINT): UINT; stdcall;

function GetRawInputDeviceList(pRawInputDeviceList: PRAWINPUTDEVICELIST;
    var puiNumDevices: UINT; cbSize: UINT): UINT;

function GetRawInputDeviceInfo(hDevice: THANDLE; uiCommand: UINT; pData: POINTER;
    var pcbSize: UINT): UINT;

function GetRawInputBuffer(pData: PRAWINPUT; var pcbSize: UINT;
    cbSizeHeader: UINT): UINT;

function GetRawInputData(hRawInput: HRAWINPUT; uiCommand: UINT; pData: POINTER;
    var pcbSize: UINT; cbSizeHeader: UINT): UINT;

function RegisterRawInputDevices(pRawInputDevices: PRAWINPUTDEVICE;
    uiNumDevices: UINT; cbSize: UINT): BOOL;

function GetRegisteredRawInputDevices(pRawInputDevices: PRAWINPUTDEVICE;
    var puiNumDevices: UINT; cbSize: UINT): UINT;

implementation

function IsWindowsNt():boolean;
var OSVersionInfo:TOSVersionInfo;
begin
 Result:=false;
 FillChar(OSVersionInfo,SizeOf(TOSVersionInfo),0);
 OSVersionInfo.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
 GetVersionEx(OSVersionInfo);
 result := OSVersionInfo.dwPlatformId = VER_PLATFORM_WIN32_NT;
end;

function GetRawInputDeviceList(pRawInputDeviceList: PRAWINPUTDEVICELIST;
    var puiNumDevices: UINT; cbSize: UINT): UINT;
var User32DllHandle:cardinal;

begin

 if IsWindowsNt() then begin
    User32DllHandle := GetModuleHandle(USER32);
    if User32DllHandle = 0 then
    begin
      User32DllHandle := LoadLibrary(USER32);
    end;
    Result := TGetRawInputDeviceList(GetProcAddress(User32DllHandle, 'GetRawInputDeviceList'))(pRawInputDeviceList,puiNumDevices,cbSize);
 end;
end;

function GetRawInputDeviceInfo (hDevice: THANDLE; uiCommand: UINT; pData: POINTER;
    var pcbSize: UINT): UINT;
var User32DllHandle:cardinal;
begin
 if IsWindowsNt() then begin
    User32DllHandle := GetModuleHandle(USER32);
    if User32DllHandle = 0 then
    begin
      User32DllHandle := LoadLibrary(USER32);
    end;
    Result := TGetRawInputDeviceInfo(GetProcAddress(User32DllHandle, 'GetRawInputDeviceInfoA'))(hDevice, uiCommand, pData,pcbSize);
 end;
end;

function GetRawInputBuffer(pData: PRAWINPUT; var pcbSize: UINT;
    cbSizeHeader: UINT): UINT;
var User32DllHandle:cardinal;
begin
 if IsWindowsNt() then begin
    User32DllHandle := GetModuleHandle(USER32);
    if User32DllHandle = 0 then
    begin
      User32DllHandle := LoadLibrary(USER32);
    end;
    Result := TGetRawInputBuffer(GetProcAddress(User32DllHandle, 'GetRawInputBuffer'))(pData, pcbSize, cbSizeHeader);
 end;
end;

function GetRawInputData(hRawInput: HRAWINPUT; uiCommand: UINT; pData: POINTER;
    var pcbSize: UINT; cbSizeHeader: UINT): UINT;
var User32DllHandle:cardinal;
begin
 if IsWindowsNt() then begin
    User32DllHandle := GetModuleHandle(USER32);
    if User32DllHandle = 0 then
    begin
      User32DllHandle := LoadLibrary(USER32);
    end;
    Result := TGetRawInputData(GetProcAddress(User32DllHandle, 'GetRawInputData'))(hRawInput, uiCommand, pData, pcbSize, cbSizeHeader);
 end;
end;

function RegisterRawInputDevices(pRawInputDevices: PRAWINPUTDEVICE;
    uiNumDevices: UINT; cbSize: UINT): BOOL;
var User32DllHandle:cardinal;
begin
 if IsWindowsNt() then begin
    User32DllHandle := GetModuleHandle(USER32);
    if User32DllHandle = 0 then
    begin
      User32DllHandle := LoadLibrary(USER32);
    end;
    Result := TRegisterRawInputDevices(GetProcAddress(User32DllHandle, 'RegisterRawInputDevices'))(pRawInputDevices, uiNumDevices, cbSize);
 end;
end;

function GetRegisteredRawInputDevices(pRawInputDevices: PRAWINPUTDEVICE;
    var puiNumDevices: UINT; cbSize: UINT): UINT;
var User32DllHandle:cardinal;
begin
 if IsWindowsNt() then begin
    User32DllHandle := GetModuleHandle(USER32);
    if User32DllHandle = 0 then
    begin
      User32DllHandle := LoadLibrary(USER32);
    end;
    Result := TGetRegisteredRawInputDevices(GetProcAddress(User32DllHandle, 'GetRegisteredRawInputDevices'))(pRawInputDevices, puiNumDevices, cbSize);
 end;
end;

end.
